/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.lawEnforcementSupervision.modular.lesprocess.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unis.lawEnforcementSupervision.modular.lesprocesslink.entity.BizLesProcessLink;
import com.unis.lawEnforcementSupervision.modular.lesprocesslink.param.BizLesProcessLinkIdParam;
import com.unis.lawEnforcementSupervision.modular.lesprocesslink.service.impl.BizLesProcessLinkServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.unis.common.enums.CommonSortOrderEnum;
import com.unis.common.exception.CommonException;
import com.unis.common.page.CommonPageRequest;
import com.unis.lawEnforcementSupervision.modular.lesprocess.entity.BizLesProcess;
import com.unis.lawEnforcementSupervision.modular.lesprocess.mapper.BizLesProcessMapper;
import com.unis.lawEnforcementSupervision.modular.lesprocess.param.BizLesProcessAddParam;
import com.unis.lawEnforcementSupervision.modular.lesprocess.param.BizLesProcessEditParam;
import com.unis.lawEnforcementSupervision.modular.lesprocess.param.BizLesProcessIdParam;
import com.unis.lawEnforcementSupervision.modular.lesprocess.param.BizLesProcessPageParam;
import com.unis.lawEnforcementSupervision.modular.lesprocess.service.BizLesProcessService;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * 执法监督-执法流程管理-执法过程Service接口实现类
 *
 * @author shine
 * @date  2024/06/22 17:25
 **/
@Service
public class BizLesProcessServiceImpl extends ServiceImpl<BizLesProcessMapper, BizLesProcess> implements BizLesProcessService {

    @Resource
    private BizLesProcessLinkServiceImpl bizLesProcessLinkServiceImpl;

    @Override
    public Page<BizLesProcess> page(BizLesProcessPageParam bizLesProcessPageParam) {
        QueryWrapper<BizLesProcess> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isNotEmpty(bizLesProcessPageParam.getProcessType())) {
            queryWrapper.lambda().eq(BizLesProcess::getProcessType, bizLesProcessPageParam.getProcessType());
        }
        if(ObjectUtil.isAllNotEmpty(bizLesProcessPageParam.getSortField(), bizLesProcessPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(bizLesProcessPageParam.getSortOrder());
            queryWrapper.orderBy(true, bizLesProcessPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(bizLesProcessPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(BizLesProcess::getId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(BizLesProcessAddParam bizLesProcessAddParam) {
        BizLesProcess bizLesProcess = BeanUtil.toBean(bizLesProcessAddParam, BizLesProcess.class);
        this.save(bizLesProcess);
        for(BizLesProcessLink bizLesProcessLink:bizLesProcess.getProcessLinkList()){
            bizLesProcessLink.setLesProcessId(bizLesProcess.getId());
            bizLesProcessLinkServiceImpl.save(bizLesProcessLink);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(BizLesProcessEditParam bizLesProcessEditParam) {
        BizLesProcess bizLesProcess = this.queryEntity(bizLesProcessEditParam.getId());
        BeanUtil.copyProperties(bizLesProcessEditParam, bizLesProcess);
        this.updateById(bizLesProcess);
        //删除 新增
        QueryWrapper<BizLesProcessLink> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("les_process_id",bizLesProcess.getId());
        bizLesProcessLinkServiceImpl.remove(queryWrapper);
        for(BizLesProcessLink bizLesProcessLink:bizLesProcess.getProcessLinkList()){
            bizLesProcessLink.setLesProcessId(bizLesProcess.getId());
            bizLesProcessLinkServiceImpl.save(bizLesProcessLink);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<BizLesProcessIdParam> bizLesProcessIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(bizLesProcessIdParamList, BizLesProcessIdParam::getId));
    }

    @Override
    public BizLesProcess detail(BizLesProcessIdParam bizLesProcessIdParam) {
        return this.queryEntity(bizLesProcessIdParam.getId());
    }

    @Override
    public BizLesProcess queryEntity(String id) {
        BizLesProcess bizLesProcess = this.getById(id);
        if(ObjectUtil.isEmpty(bizLesProcess)) {
            throw new CommonException("执法监督-执法流程管理-执法过程不存在，id值为：{}", id);
        }
        return bizLesProcess;
    }
}
